const mongoose = require("mongoose");
const Schema = mongoose.Schema;
const connection = require("../../db/connection");

var addPostSchema = new Schema({
  category_id: {
    type: String,
    require: true
  },
  tagdata_id: {
    type: String,
    require: true,
  },
  authorProfile_id:{
    type: String,
    require: true
  },
  post_title: {
    type: String,
    require: true,
  },
  post_content: {
    type: String,
    require: true,
  },
  metatitle: {
    type: String,
    require: true,
  },
  metadescription: {
    type: String,
    require: true,
  },
  focuskeyword: {
    type: String,
    require: true,
  },
  faqs: [{
    question: {
      type: String,
    },
    answer: {
      type: String,
    }
  }],
  post_category: {
    type: String,
    require: true,
  },
  post_tag: {
    type: String,
    require: true,
  },
  selectedImagid: {
    type: String,
    require: true,
  },
  imagefilePath: {
    type: String,
    require: true,
  },
  img_alt: {
    type: String,
    require: true
  },
  slug: {
    type: String,
  },
  authorName: {
    type: String
  },
  authordescription: {
    type: String
  },
  authorProfile_img: {
    type: String
  },
  status: {
    type: Number,
    default: 0,
    required: true,
  },
  isPost: {
    type: Number,
    default: 1,
    required: true,
  },
  created_at: {
    type: Date,
    required: true,
    default: Date.now
  },
  updated_at: {
    type: Date,
    required: true,
    default: Date.now
  },
});
var addPost = connection.model("addPost", addPostSchema);
module.exports = addPost;