const mongoose = require("mongoose");
const Schema = mongoose.Schema;
const connection = require("../../db/connection");

var newPageSchema = new Schema({
  page_title: {
    type: String,
    require: true,
  },
  page_content: {
    type: String,
    require: true,
  },
  metatitle: {
    type: String,
    require: true,
  },
  metadescription: {
    type: String,
    require: true,
  },
  focuskeyword: {
    type: String,
    require: true,
  },
  faqs: [{
    question: {
      type: String,
    },
    answer: {
      type: String,
    }
  }],
  selectedImagid: {
    type: String,
    require: true,
  },
  imagefilePath: {
    type: String,
    require: true,
  },
  img_alt: {
    type: String,
    require: true
  },
  slug: {
    type: String,
  },
  status: {
    type: Number,
    default: 0,
    required: true,
  },
  created_at: {
    type: Date,
    required: true,
    default: Date.now
  },
  updated_at: {
    type: Date,
    required: true,
    default: Date.now
  },
});
var newPage = connection.model("newpage", newPageSchema);
module.exports = newPage;
