require('dotenv').config();
const express = require("express");
const createError = require("http-errors");
const router = express.Router();
const Account = require("../models/account");
const bcrypt = require("bcrypt");
const axios = require('axios');

// Send email for registration
"use strict";
const nodemailer = require("nodemailer");
// async function postDatamail(data) {
//   console.log('main data', data.email);
//   var nm = data.name;

// var new_nm = nm.replaceAll(' ', '_');
// const url = 'https://9estate.com/mail/mail.php?email='+data.email+'&name_new='+new_nm+'&encoded_email='+data.path_url; // Replace with your PHP server URL and endpoint

// try {
//   const response = await axios.post(url, data);
//   console.log('Post request successful!', response.data);
//   // Handle the response from the PHP server
// } catch (error) {
//   console.error('Error occurred:', error);
//   // Handle the error
// }
// }

 router.get('/useraccounts', async (req, res, next) => {
  try {
    var currentuserid = String(req.query.storage_data);
    const data = await Account.find({ _id : currentuserid,role:"2" })
    const total_accounts = await Account.countDocuments({ _id : currentuserid,role:"2" });
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})

 // Get Agent Account menu
 router.get('/agentaccounts', async (req, res, next) => {
  try {
    var currentuserid = String(req.query.storage_data);
    const data = await Account.find({ _id : currentuserid ,role: { $in : ["1", "3"]}})
    const total_accounts = await Account.countDocuments({ _id : currentuserid,role: { $in : ["1", "3"]}});
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})

//Change User password
router.get('/userchengepassword', async (req, res, next) => {
  try {
    const user_id= req.query.user_id;
    const find = await Account.findOne({ _id: user_id });
    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(req.query.cnfpassword, salt);
    if (find) {
      const option = { new: true };
      const updatedDetails = await Account.findByIdAndUpdate(find._id, {password
        :newpassword}, option);

      res.send({status:1});
    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});
//agntresetpassword
router.get('/agntresetpassword', async (req, res, next) => {
  try {
    const password = req.query.password;
    const encoded_email = req.query.encoded_email;
    const find = await Account.findOne({ verification: encoded_email });
    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(password, salt);
    if (find) {
      const option = { new: true };
      const updatedDetails = await Account.findByIdAndUpdate(find._id, {password
        :newpassword, verification:'0', encoded_email:'', emailverify:1}, option);

      res.send({status:1});
    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});

//Change Agent password
router.get('/agntchengepassword', async (req, res, next) => {
  try {
    const agent_id= req.query.agent_id;
    const find = await Account.findOne({ _id: agent_id });
    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(req.query.cnfpassword, salt);
    if (find) {
      const option = { new: true };
      const updatedDetails = await Account.findByIdAndUpdate(find._id, {password
        :newpassword}, option);
        const data = await Account.find({ _id : find._id});

        res.send({status:1, data:data});


    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});
//Agent url match
router.get('/agenturlmatch', async (req, res, next) => {
  try {
    const encoded_email = req.query.encoded_email;
    const find = await Account.findOne({ verification: encoded_email });
    if (find) {
      res.send({status:1});
    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});
//Get Agent Name for enquiry
router.get('/agentName', async (req, res, next) => {
  try {
    const loginid = req.query.loginid;
    const data = await Account.find({_id: loginid})
    const total_data = await Account.countDocuments({_id: loginid});
    res.send({
      total: total_data,
      AgentName: data,
    });
  } catch (error) {
   next(error)
  }
});
router.get('/checkemail', async (req, res, next) => {
  try {
    const email = req.query.email;
    const pathUrl = req.query.pathUrl;
    const find = await Account.findOne({ email: email });
    if (find) {
      const option = { new: true };
      const updatedDetails = await Account.findByIdAndUpdate(find._id, {verification
        :req.query.encoded_email}, option);
      resetPasswordmail(email,find.name,pathUrl).catch(console.error);
      res.send({status:1});
    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});
//get Agents Account
router.get('/agentsAccounts', async (req, res, next) => {
  try {
    const data = await Account.find({role:"1"})
    const total_accounts = await Account.countDocuments({role:"1"});
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})
//get Account
router.get('/accounts', async (req, res, next) => {
  try {
    const data = await Account.find({role:"1"})
    const total_accounts = await Account.countDocuments({role:"1"});
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})
//get Account naya
router.get('/accounts_all_for_admin', async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;
    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const accountsCollection = await Account.find({
        role_type: { "$ne": 'admin' },
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
          { email: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({
        role_type: { "$ne": 'admin' },
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
          { email: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      });
      res.send({
        total: total_pages,
        accounts: accountsCollection,
      });
    } else {
      const accountCollection = await Account.find({ role_type: { "$ne": 'admin' } })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({ role_type: { "$ne": 'admin' } });
      res.send({
        total: total_pages,
        accounts: accountCollection,
      });
    }
  } catch (error) {
    next(error);
  }
})

router.get('/accounts_all_for_admin_for_role_id', async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const role = String(req.query.role);
    const skips = limit * offset;
    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const accountsCollection = await Account.find({role:role, role_type: { "$ne": 'admin' },
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
          { email: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:role, role_type: { "$ne": 'admin' },
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
          { email: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      });
      res.send({
        total: total_pages,
        accounts: accountsCollection,
      });
    } else {
      const accountCollection = await Account.find({role:role})
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:role});
      res.send({
        total: total_pages,
        accounts: accountCollection,
      });
    }
  } catch (error) {
    next(error);
  }


})
router.get('/accounts_all_for_subadmin', async (req, res, next) => {
  try {
    const data = await Account.find({role: { "$ne": '0' }})
    const total_accounts = await Account.countDocuments({role_type: { "$ne": 'admin' }});
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})
//get Admin Account
router.get('/adminaccounts', async (req, res, next) => {
  try {
    const data = await Account.find({role:"0"})
    const total_accounts = await Account.countDocuments({role:"0"});
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
});
//get Admin Account by id 
router.get('/getadminaccounts', async (req, res, next) => {
  try {
    const id= req.query.storage_data;
    const data = await Account.find({_id:id})
    res.send({
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})

//get admin details
router.get('/accounts/:adminid',(req, res,next)=>{

})
router.post("/checkadminlogin", async (req, res, next) => {
  try {
    const email = String(req.body.uname);
    const password = String(req.body.password);
    const find = await Account.findOne({ email:String(req.body.uname), role:"0" });
    if (find === null) {
      res.send({status:0});
    } else {
      const trueUser = await bcrypt.compare(password, find.password);
      if(trueUser==false){
          res.send({status:0});
      }else{
          res.send({
          id: find._id,
          userId: find.uname,
          role: find.role,
          role_type: find.role_type,
          status:1
        });
      }
    }
  } catch (error) {

    next(error);
  }
})
// Agent verification
router.get("/agentemailverification", async (req, res, next) => {
   try {
    const email = String(req.query.encoded_email);
    const find = await Account.findOne({ encoded_email:email });
    if (find === null) {
         res.send({status:0});
    } else {
        const update = {encoded_email:'', emailverify:1};
        const id = find.id;
        const option = { new: true };
        const updatedDetails = await Account.findByIdAndUpdate(id, update, option);
        res.send({status:1});

    }
  } catch (error) {
     next(error);
   }
})
//Search admin account
router.get("/getadminaccountssearch", async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;
    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const accountsCollection = await Account.find({role:"0",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"0",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
        ],
      });
      res.send({
        total: total_pages,
        data: accountsCollection,
      });
    } else {
      const accountCollection = await Account.find({role:"0"})
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"0"});
      res.send({
        total: total_pages,
        data: accountCollection,
      });
    }
  } catch (error) {
    next(error);
  }
});
//Search agent account

router.get('/checkEmail_url', async (req, res, next) => {
  try {
    const email = req.query.email;
    const find = await Account.findOne({ email: email });
    if (find) {
      res.send({ data: find });
    }else{
      res.send({ data:'0' });
    }
  } catch (error) {
   next(error)
  }
});


router.get('/agent/checkurl/:slug/:slug_url', async (req, res, next) => {
  try {
    const data = await Account.find({slug_url:req.params.slug+'/'+req.params.slug_url})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
router.get("/getaccountssearch", async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;
    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const accountsCollection = await Account.find({role:"1",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"1",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
        ],
      });
      res.send({
        total: total_pages,
        data: accountsCollection,
      });
    } else {
      const accountCollection = await Account.find({role:"1"})
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"1"});
      res.send({
        total: total_pages,
        data: accountCollection,
      });
    }
  } catch (error) {
    next(error);
  }
});
//get Account by ID
router.get('/accounts/:id', async (req, res, next) => {

  try {
    const data = await Account.find({_id:req.params.id,role:"1"});
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
//Create Account
router.post("/accounts", async (req, res, next) => {
  //  main(req.body.email,req.body.name,req.body.pathUrl).catch(console.error);
  try {

    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(req.body.password, salt);
    const accountsave = new Account({
        company_id:req.body.company_id,
        name:req.body.name,
        mobile:req.body.mobile,
        email:req.body.email,
        password:newpassword,
        description:req.body.description,
        role:req.body.role,
        emailverify:req.body.emailverify,
        encoded_email:req.body.encoded_email,
        join_dt:req.body.join_dt,
        update_dt:req.body.update_dt,
        status:req.body.status
    });
    const addaccount = await accountsave.save();
    res.send(addaccount);
  } catch (error) {
    next(error);
  }
});
//create new
router.post("/accounts_new", async (req, res, next) => {
  main(req.body.email,req.body.name,req.body.pathUrl).catch(console.error);
 try {

   const salt = await bcrypt.genSalt(10);
   const newpassword = await bcrypt.hash(req.body.password, salt);
   const accountsave = new Account({
       company_id:req.body.company_id,
       name:req.body.name,
       mobile:req.body.mobile,
       email:req.body.email,
       password:newpassword,
       description:req.body.description,
       role:req.body.role,
       role_type:req.body.role_type,
       emailverify:req.body.emailverify,
       encoded_email:req.body.encoded_email,
       join_dt:req.body.join_dt,
       update_dt:req.body.update_dt,
       status:req.body.status
   });
   const addaccount = await accountsave.save();
   res.send(addaccount);
 } catch (error) {
   next(error);
 }
});

//Delete Account
router.delete("/accounts/:id", async (req, res, next) => {
  try {
    const id = req.params.id;
    const find = await Account.findOne({ _id: id });
    if (find) {
      const deleted = await Account.findByIdAndDelete({ _id: id });
      res.send(deleted);
    } else {
      res.send("Id does not exist");
    }
  } catch (error) {
   next(error)
  }

});
// ===================================================
                    //route for agent
// ===================================================
//get Account
router.get('/agentaccounts', async (req, res, next) => {
  try {
    var currentloginid = String(req.query.storage_data);
    const data = await Account.find({ _id : currentloginid,role:"1" })
    const total_accounts = await Account.countDocuments({ _id : currentloginid,role:"1" });
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})

//get user account detais

router.get('/useraccounts', async (req, res, next) => {
  try {
    var currentloginid = String(req.query.storage_data);
    const data = await Account.find({ _id : currentloginid,role:"2" })
    const total_accounts = await Account.countDocuments({ _id : currentloginid,role:"2" });
    res.send({
      total: total_accounts,
      accounts: data,
    });
  }
  catch (error) {
    next(error)
  }
})

router.post("/checklogin", async (req, res, next) => {
  try {
    const email = String(req.body.uname);
    const password = String(req.body.password);
    //checking username for login
    const find = await Account.findOne({ email:String(req.body.uname)});
    if (find === null) {
      //checking email for login
      const find2 = await Account.findOne({ email:String(req.body.uname)});
      if (find2 === null) {
        res.send({status:0});
      } else {
        if(find2.status==0){
          res.send({status:4});
        }else{
        const trueUser = await bcrypt.compare(password, find2.password);
          if(trueUser==false){
              res.send({status:2});
          }else{
            if(find2.emailverify==1){
              res.send({
                id: find2._id,
                userId: find2.email,
                role: find2.role,
                status:1
              });
            }else{
              res.send({status:3});
            }

          }
        }
      }
    }
    else {
      const trueUser = await bcrypt.compare(password, find.password);
      if(trueUser==false){
          res.send({status:2});
      }else{
        if(find.status==0){
          res.send({status:4});
        }else{
          if(find.emailverify==0){
            res.send({
              id: find._id,
              userId: find.uname,
              role: find.role,
              status:1
            });
          }else{
            res.send({status:3});
          }
        }
      }
    }
  } catch (error) {

    next(error);
  }
})
router.get("/getagentaccountssearch", async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;
    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const accountsCollection = await Account.find({role:"1",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"1",
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
        ],
      });
      res.send({
        total: total_pages,
        data: accountsCollection,
      });
    } else {
      const accountCollection = await Account.find({role:"1"})
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await Account.countDocuments({role:"1"});
      res.send({
        total: total_pages,
        data: accountCollection,
      });
    }
  } catch (error) {
    next(error);
  }
});
//get Account by ID
router.get('/accounts/:id', async (req, res, next) => {

  try {
    const data = await Account.find({_id:req.params.id})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
//Create Account
// router.post("/accounts", async (req, res, next) => {
//   try {
//     const salt = await bcrypt.genSalt(10);
//     const newpassword = await bcrypt.hash(req.body.password, salt);
//     const accountsave = new Account({
//         company_id:req.body.company_id,
//         name:req.body.name,
//         mobile:req.body.mobile,
//         email:req.body.email,
//         password:newpassword,
//         description:req.body.description,
//         role:req.body.role,
//         join_dt:req.body.join_dt,
//         update_dt:req.body.update_dt,
//         status:req.body.status
//     });
//     const addaccount = await accountsave.save();
//     res.send(addaccount);
//   } catch (error) {
//     next(error);
//   }
// });

//**************************************************************** */
                    //Create my excel Account
//**************************************************************** */

router.post("/accountsNewSave", async (req, res, next) => {
  try {

    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(req.body.password, salt);
    const accountsave = new Account({
        fullname: req.body.fullname,
        username: req.body.username,
        email:req.body.email,
        password:newpassword,
        about:req.body.about,
        facebook:req.body.facebook,
        instagram:req.body.instagram,
        linkedin:req.body.linkedin,
        youtube:req.body.youtube,
        role:req.body.role,
        emailverify:req.body.emailverify,
        encoded_email:req.body.encoded_email,
        slug:req.body.slug,
        slug_url:req.body.slug_url,
        join_dt:req.body.join_dt,
        update_dt:req.body.update_dt,
        status:req.body.status
    });
    const addaccount = await accountsave.save();
    res.send(addaccount);
  } catch (error) {
    next(error);
  }
});
//************************************************************************ */
                  //Update excel Account
//************************************************************************ */
router.patch("/excelaccounts/:id", async (req, res, next) => {
  try {
    const update = req.body;
    const id = req.params.id;
    const option = { new: true };
    const updatedDetails = await Account.findByIdAndUpdate(id, update, option);
    res.send(updatedDetails);
  } catch (error) {
    next(error);
  }
});

//Change password
router.get('/adminchengepassword', async (req, res, next) => {
  try {
    const admin_id= req.query.admin_id;
    const find = await Account.findOne({ _id: admin_id});
    const salt = await bcrypt.genSalt(10);
    const newpassword = await bcrypt.hash(req.query.cnfpassword, salt);
    if (find) {
      const option = { new: true };
      const updatedDetails = await Account.findByIdAndUpdate(find._id, {password
        :newpassword}, option);
        const data = await Account.find({ _id : find._id});
    
        res.send({status:1, data:data});
    
      
    } else {
      res.send({status:0});
    }
  } catch (error) {
   next(error)
  }
});

//Update aget Account
router.patch("/agentupdateaccounts/:id", async (req, res, next) => {
  try {
    const update = req.body;
    const id = req.params.id;
    const option = { new: true };
    const updatedDetails = await Account.findByIdAndUpdate(id, update, option);
    res.send(updatedDetails);
  } catch (error) {
    next(error);
  }
});
router.get('/getagentbyid/:id', async (req, res, next) => {
  try {
    const data = await Account.find({_id:req.params.id})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
router.get('/getagentbySlug/:slug', async (req, res, next) => {
  try {
    const data = await Account.find({slug:req.params.slug})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
//Delete Account
router.delete("/agentsaccounts/:id", async (req, res, next) => {
  try {
    const id = req.params.id;
    const find = await Account.findOne({ _id: id });
    if (find) {
      const deleted = await Account.findByIdAndDelete({ _id: id});
      res.send(deleted);
    } else {
      res.send("Id does not exist");
    }
  } catch (error) {
   next(error)
  }
});


// Get author by id for filter
router.get('/author_Slug', async (req, res) => {
  try {
    const dataauthor = await Account.find({ _id: req.query.id })
    res.send({dataauthor})
  }
  catch (error) {
   
  }
});

module.exports = router;

