const express = require("express");
const createError = require("http-errors");
const router = express.Router();
const footerOne = require("../models/footer-wedget-one");

//get tag
router.get('/footerone', async (req, res, next) => {
    try {
        const data = await footerOne.find()
        const total_data = await footerOne.countDocuments();
        res.send({
        total: total_data,
        footerOne: data,
        });
      }
      catch (error) {
      next(error)
      }
    })
    //get Tag By Slug
      router.get("/tag_by_slug/:slug", async (req, res, next) => {
      try {
      const data = await footerOne.find({slug:req.params.slug})
      res.send({ data: data })
      }
      catch (error) {
      next(error)
      }
      });
        //get tag
router.get('/getallTag', async (req, res, next) => {

  try {
    const data = await footerOne.find();
    res.send(data);
  }
  catch (error) {
    next(error)
  }
})


router.get("/getfooteronesearch", async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;

    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const postCollection = await footerOne.find({
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await footerOne.countDocuments({
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
        ],
      });
      res.send({
        total: total_pages,
        data: postCollection,
      });
    } else {
      const postCollection = await footerOne.find()
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await footerOne.countDocuments();
      res.send({
        total: total_pages,
        data: postCollection,
      });
    }
  } catch (error) {
    next(error);
  }
});
//get footerOne by ID
router.get('/footerone/:id', async (req, res, next) => {

  try {
    const data = await footerOne.find({_id:req.params.id})
    res.send({ data: data })

  }
  catch (error) {
    next(error)
  }
})
//Create footerone
router.post("/footerone", async (req, res, next) => {
  try {
    const {
    address,
    email,
    contact,
    status,
    created_at,
    updated_at,
    } = req.body;
    const myfooterone = new footerOne({
      address,
      email,
      contact,
      status,
      created_at,
      updated_at,
    });
    const addfooterone = await myfooterone.save();
    res.send(addfooterone);
  } catch (error) {
    next(error);
  }
});
//Update footerone
router.patch("/footerone/:id", async (req, res, next) => {
  try {
    const update = req.body;
    const id = req.params.id;
    const option = { new: true };
    const updatedDetails = await footerOne.findByIdAndUpdate(id, update, option);
    res.send(updatedDetails);
  } catch (error) {
    next(error);
  }
});
//Delete footerone
router.delete("/footerone/:id", async (req, res, next) => {
  try {
    const id = req.params.id;
    const find = await footerOne.findOne({ _id: id });
    if (find) {
      const deleted = await footerOne.findByIdAndDelete({ _id: id });
      res.send(deleted);
    } else {
      res.send("Id does not exist");
    }
  } catch (error) {
   next(error)
  }
});
router.get('/check_tagslug/:slug', async (req, res, next) => {
  try {
    const data = await footerOne.find({slug:req.params.slug})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
module.exports = router;

