const express = require("express");
const createError = require("http-errors");
const router = express.Router();
const footerThree = require("../models/footer-Wedget-three");

//get tag
router.get('/footerthree', async (req, res, next) => {
    try {
        const data = await footerThree.find()
        const total_data = await footerThree.countDocuments();
        res.send({
            total: total_data,
            footerThree: data,
        });
    }
    catch (error) {
        next(error)
    }
})

router.get("/getfooterthreesearch", async (req, res, next) => {
    try {
        const limit = parseInt(req.query.limit);
        const offset = parseInt(req.query.offset);
        const search = String(req.query.searchdata);
        const skips = limit * offset;

        var sortObject = {};
        var sort_col = String(req.query.sort_col);
        var sort_order = String(req.query.sort_order);
        sortObject[sort_col] = sort_order;
        if (search) {
            const colName = search;
            const postCollection = await footerThree.find({
                $or: [
                    { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
                ],
            })
                .skip(skips)
                .limit(limit)
                .sort(sortObject);
            const total_pages = await footerThree.countDocuments({
                $or: [
                    { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
                ],
            });
            res.send({
                total: total_pages,
                data: postCollection,
            });
        } else {
            const postCollection = await footerThree.find()
                .skip(skips)
                .limit(limit)
                .sort(sortObject);
            const total_pages = await footerThree.countDocuments();
            res.send({
                total: total_pages,
                data: postCollection,
            });
        }
    } catch (error) {
        next(error);
    }
});
//get footerThree by ID
router.get('/footerthree/:id', async (req, res, next) => {

    try {
        const data = await footerThree.find({ _id: req.params.id })
        res.send({ data: data })

    }
    catch (error) {
        next(error)
    }
})
//Create footerthree
router.post("/footerthree", async (req, res, next) => {
    try {
        const {
            name,
            link,
            status,
            created_at,
            updated_at,
        } = req.body;
        const myfooterthree = new footerThree({
            name,
            link,
            status,
            created_at,
            updated_at,
        });
        const addfooterthree = await myfooterthree.save();
        res.send(addfooterthree);
    } catch (error) {
        next(error);
    }
});
//Update footerthree
router.patch("/footerthree/:id", async (req, res, next) => {
    try {
        const update = req.body;
        const id = req.params.id;
        const option = { new: true };
        const updatedDetails = await footerThree.findByIdAndUpdate(id, update, option);
        res.send(updatedDetails);
    } catch (error) {
        next(error);
    }
});
//Delete footerthree
router.delete("/footerthree/:id", async (req, res, next) => {
    try {
        const id = req.params.id;
        const find = await footerThree.findOne({ _id: id });
        if (find) {
            const deleted = await footerThree.findByIdAndDelete({ _id: id });
            res.send(deleted);
        } else {
            res.send("Id does not exist");
        }
    } catch (error) {
        next(error)
    }
});
module.exports = router;