const express = require("express");
const createError = require("http-errors");
const router = express.Router();
const headerMenu = require("../models/header-menu");

//get tag
router.get('/headermenu', async (req, res, next) => {
    try {
        const data = await headerMenu.find()
        const total_data = await headerMenu.countDocuments();
        res.send({
            total: total_data,
            headerMenu: data,
        });
    }
    catch (error) {
        next(error)
    }
});
//get data By id
router.get("/headermenu_by_id/:id", async (req, res, next) => {
  try {
  const data = await headerMenu.find({_id:req.params.id})
  res.send({ data: data })
  }
  catch (error) {
  next(error)
  }
  });

router.get("/getfooterthreesearch", async (req, res, next) => {
    try {
        const limit = parseInt(req.query.limit);
        const offset = parseInt(req.query.offset);
        const search = String(req.query.searchdata);
        const skips = limit * offset;
        var sortObject = {};
        var sort_col = String(req.query.sort_col);
        var sort_order = String(req.query.sort_order);
        sortObject[sort_col] = sort_order;
        if (search) {
            const colName = search;
            const postCollection = await headerMenu.find({
                $or: [
                    { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
                ],
            })
                .skip(skips)
                .limit(limit)
                .sort(sortObject);
            const total_pages = await headerMenu.countDocuments({
                $or: [
                    { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
                ],
            });
            res.send({
                total: total_pages,
                data: postCollection,
            });
        } else {
            const postCollection = await headerMenu.find()
                .skip(skips)
                .limit(limit)
                .sort(sortObject);
            const total_pages = await headerMenu.countDocuments();
            res.send({
                total: total_pages,
                data: postCollection,
            });
        }
    } catch (error) {
        next(error);
    }
});
//get headerMenu by ID
router.get('/headermenu/:id', async (req, res, next) => {
    try {
        const data = await headerMenu.find({ _id: req.params.id })
        res.send({ data: data })

    }
    catch (error) {
        next(error)
    }
})
//Create headermenu
router.post("/headermenu", async (req, res, next) => {
    try {
        const {
            name,
            link,
            slug,
            status,
            Megastatus,
            imagefilePath,
            created_at,
            updated_at,
        } = req.body;
        const myheadermenu = new headerMenu({
            name,
            link,
            slug,
            status,
            Megastatus,
            imagefilePath,
            created_at,
            updated_at,
        });
        const addheadermenu = await myheadermenu.save();
        res.send(addheadermenu);
    } catch (error) {
        next(error);
    }
});
//Update headermenu
router.patch("/headermenu/:id", async (req, res, next) => {
    try {
        const update = req.body;
        const id = req.params.id;
        const option = { new: true };
        const updatedDetails = await headerMenu.findByIdAndUpdate(id, update, option);
        res.send(updatedDetails);
    } catch (error) {
        next(error);
    }
});
//Delete headermenu
router.delete("/headermenu/:id", async (req, res, next) => {
    try {
        const id = req.params.id;
        const find = await headerMenu.findOne({ _id: id });
        if (find) {
            const deleted = await headerMenu.findByIdAndDelete({ _id: id });
            res.send(deleted);
        } else {
            res.send("Id does not exist");
        }
    } catch (error) {
        next(error)
    }
});
module.exports = router;
