
const express = require("express");
const createError = require("http-errors");
const router = express.Router();
const excelsitelog = require("../models/mylogo");

//get tag
router.get('/uploadlogo', async (req, res, next) => {
    try {
        const data = await excelsitelog.find()
        const total_post = await excelsitelog.countDocuments();
        res.send({
        total: total_post,
        excelsitelog: data,
        });
      }
      catch (error) {
      next(error)
      }
    })
    //get Tag By Slug
      router.get("/tag_by_slug/:slug", async (req, res, next) => {
      try {
      const data = await excelsitelog.find({slug:req.params.slug})
      res.send({ data: data })
      }
      catch (error) {
      next(error)
      }
      });
        //get tag
router.get('/getallTag', async (req, res, next) => {

  try {
    const data = await excelsitelog.find();
    res.send(data);
  }
  catch (error) {
    next(error)
  }
})


router.get("/getposttagssearch", async (req, res, next) => {
  try {
    const limit = parseInt(req.query.limit);
    const offset = parseInt(req.query.offset);
    const search = String(req.query.searchdata);
    const skips = limit * offset;

    var sortObject = {};
    var sort_col = String(req.query.sort_col);
    var sort_order = String(req.query.sort_order);
    sortObject[sort_col] = sort_order;
    if (search) {
      const colName = search;
      const postCollection = await excelsitelog.find({
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } },
        ],
      })
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await excelsitelog.countDocuments({
        $or: [
          { name: { $regex: new RegExp("^" + colName.toLowerCase(), "i") } }
        ],
      });
      res.send({
        total: total_pages,
        data: postCollection,
      });
    } else {
      const postCollection = await excelsitelog.find()
        .skip(skips)
        .limit(limit)
        .sort(sortObject);
      const total_pages = await excelsitelog.countDocuments();
      res.send({
        total: total_pages,
        data: postCollection,
      });
    }
  } catch (error) {
    next(error);
  }
});
//get excelsitelog by ID
router.get('/uploadlogo/:id', async (req, res, next) => {

  try {
    const data = await excelsitelog.find({_id:req.params.id})
    res.send({ data: data })

  }
  catch (error) {
    next(error)
  }
})
//Create post
router.post("/uploadlogo", async (req, res, next) => {
  try {
    const {
      imagefileId,
      imagefilePath,
      status,
      created_at,
      updated_at,
    } = req.body;
    const mypost = new excelsitelog({
      imagefileId,
      imagefilePath,
      status,
      created_at,
      updated_at,
    });
    const addpost = await mypost.save();
    res.send(addpost);
  } catch (error) {
    next(error);
  }
});
//Update post
router.patch("/uploadlogo/:id", async (req, res, next) => {
  try {
    const update = req.body;
    const id = req.params.id;
    const option = { new: true };
    const updatedDetails = await excelsitelog.findByIdAndUpdate(id, update, option);
    res.send(updatedDetails);
  } catch (error) {
    next(error);
  }
});
//Delete post
router.delete("/uploadlogo/:id", async (req, res, next) => {
  try {
    const id = req.params.id;
    const find = await excelsitelog.findOne({ _id: id });
    if (find) {
      const deleted = await excelsitelog.findByIdAndDelete({ _id: id });
      res.send(deleted);
    } else {
      res.send("Id does not exist");
    }
  } catch (error) {
   next(error)
  }
});
router.get('/check_tagslug/:slug', async (req, res, next) => {
  try {
    const data = await excelsitelog.find({slug:req.params.slug})
    res.send({ data: data })
  }
  catch (error) {
    next(error)
  }
})
module.exports = router;

